theory Loop_Checker_Sound_Demo
imports 
  Loop_Checker_Demo
  Loops_Demo
begin
  
section \<open>Soundness proof\<close>

lemma aim: "check_loop R prf \<Longrightarrow> \<not> SN (rstep R)" 
  oops
    
lemma aim_1: "check_loop R prf \<Longrightarrow> \<exists> t C \<sigma>. (t, C\<langle> t \<cdot> \<sigma> \<rangle>) \<in> (rstep R)^+"
  oops
    
lemma aim_2: "(t, C\<langle> t \<cdot> \<sigma> \<rangle>) \<in> (rstep R)^+ \<Longrightarrow> \<not> SN (rstep R)" 
  oops

text \<open>Start with checking rewrite step\<close>
lemma check_rstep_wit:
  assumes "check_rstep_wit R wit s t"
  shows "(s, t) \<in> rstep R"
proof -
  show ?thesis sorry
qed

    
text \<open>Next derivations\<close>
lemma check_derivation:
  assumes "check_derivation R s seq = Some t"
  shows "(s, t) \<in> rstep R ^^ length seq"
  using assms
  sorry

text \<open>Finally loops\<close>
lemma check_loop:
  assumes "check_loop R prf"
  shows "\<exists> t C \<sigma>. (t, C\<langle> t \<cdot> \<sigma> \<rangle>) \<in> (rstep R)^+"
  sorry
    
text \<open>Combination with "loop implies nontermination"\<close>
lemma check_loop_not_SN:
  assumes "check_loop R prf"
  shows "\<not> SN (rstep R)"
  sorry
end