theory Nontermination_Checker_3
imports
  Loop_Checker_3
  "~~/src/HOL/Library/Code_Char" 
  "$AFP/Show/Show_Instances" 
  "$AFP/Certification_Monads/Check_Monad"
begin  
  
datatype ('f, 'v) non_term_proof =
  Loop "('f, 'v) loop_proof" |
  Rule_Removal
    "('f, 'v) rule list" -- \<open>rules which should be removed\<close>
    "('f, 'v) non_term_proof"
        
fun check_non_term :: "('f :: show,'v :: show)trs \<Rightarrow> ('f,'v)non_term_proof \<Rightarrow> shows check" where
  "check_non_term R (Loop prf) = check_loop R prf 
     <+? (\<lambda> s. shows ''error in loop proof\<newline>'' o s)" |
  "check_non_term R (Rule_Removal D prf) = (do {
      check (set D \<subseteq> R) (shows ''not a subset'');
      check_non_term (R - set D) prf})" 
  
lemma rstep_subset: assumes "R \<subseteq> S" 
  shows "rstep R \<subseteq> rstep S" 
proof 
  fix s t
  assume "(s,t) \<in> rstep R"
  thus "(s,t) \<in> rstep S" using assms
    by (induct, auto intro: rstep)
qed
  
lemma check_non_term: "isOK(check_non_term R prf) \<Longrightarrow> \<not> SN (rstep R)" 
proof (induct "prf" arbitrary: R)
  case (Loop p R)
  with check_loop_not_SN show ?case by auto
next
  case (Rule_Removal D p R)
  hence nSN: "\<not> SN (rstep (R - set D))" by auto  
  show "\<not> SN (rstep R)"
  proof
    assume SN: "SN (rstep R)" 
    have "SN (rstep (R - set D))"
      by (rule SN_subset[OF SN rstep_subset], auto)
    with nSN show False by auto
  qed
qed
  
definition main_checker :: "(string,string)trs \<Rightarrow> (string,string) non_term_proof \<Rightarrow> string" where
  "main_checker R prf = (case check_non_term R prf of 
    Inr _ \<Rightarrow> ''certified nontermination'' 
  | Inl e \<Rightarrow> (shows ''rejected, reason: \<newline>'' o e) '''')" 
  
end
