theory Nontermination_Test
imports 
  "~~/src/HOL/Library/Code_Char" (* map Isabelle strings to target language strings *)
  Loop_Checker_Demo
  (* Loop_Checker_Sound *)
begin
  
definition "example_trs = {
  (Fun ''g'' [Var ''x''], Fun ''f'' [Fun ''g'' [Fun ''h'' [Var ''x'']]])}"

definition "example_certificate =
  (let
    x = Var ''x'';
    gx = Fun ''g'' [x];
    hx = Fun ''h'' [x];
    ghx = Fun ''g'' [hx];
    fghx = Fun ''f'' [ghx];
    step_wit = ((gx, fghx), \<box>);
    C = More ''f'' [] \<box> [];
    \<sigma> = [(''x'', hx)]
  in Loop_Proof gx [(step_wit, fghx)] C \<sigma>)"

value (code) "main_checker example_trs example_certificate"

export_code main_checker example_trs example_certificate
  in Haskell module_name Nontermination_Checker_Ex file "./Code"

(* soundness proof required *)
lemma example_is_non_terminating: "\<not> SN (rstep example_trs)"
  oops (*
  apply (rule check_loop_not_SN[of _ example_certificate])
  apply code_simp
  done *)
    
end
